package me.icymint.libra.sage.datasource;

import java.beans.PropertyVetoException;

import javax.sql.DataSource;

import org.apache.commons.dbcp.BasicDataSource;

import com.jolbox.bonecp.BoneCPDataSource;
import com.mchange.v2.c3p0.ComboPooledDataSource;

/**
 * 数据库工厂，生成数据源。
 * 
 * @author Daniel
 * @datetime 2012-11-9下午3:01:35
 * 
 */
public class DataSourceFactory {
	public static DataSource getBoneCPDataSource(String driver, String url,
			String username, String password) {
		BoneCPDataSource ds = new BoneCPDataSource();
		ds.setDriverClass(driver);
		ds.setJdbcUrl(url);
		ds.setUsername(username);
		ds.setPassword(password);
		return ds;
	}

	public static DataSource getC3p0DataSource(String driver, String url,
			String username, String password) {
		ComboPooledDataSource ds = new ComboPooledDataSource();
		try {
			ds.setDriverClass(driver);
		} catch (PropertyVetoException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return null;
		}
		ds.setJdbcUrl(url);
		ds.setUser(username);
		ds.setPassword(password);
		return ds;
	}

	public static DataSource getDbcpDataSource(String driver, String url,
			String username, String password) {
		BasicDataSource ds = new BasicDataSource();
		ds.setDriverClassName(driver);
		ds.setUrl(url);
		ds.setUsername(username);
		ds.setPassword(password);
		return ds;
	}

	// public static DataSource getProxoolDataSource(String driver, String url,
	// String username, String password) {
	// ProxoolDataSource ds = new ProxoolDataSource();
	// ds.setDriver(driver);
	// ds.setDriverUrl(url);
	// ds.setUser(username);
	// ds.setPassword(password);
	// return ds;
	// }

	public static DataSource getTomcatDataSource(String driver, String url,
			String username, String password) {
		org.apache.tomcat.jdbc.pool.DataSource ds = new org.apache.tomcat.jdbc.pool.DataSource();
		ds.setDriverClassName(driver);
		ds.setUrl(url);
		ds.setUsername(username);
		ds.setPassword(password);
		return ds;
	}
}
